searchData={"items":[{"type":"module","title":"FlyMachineClient.Machines","doc":"Module for managing machines on Fly.io.","ref":"FlyMachineClient.Machines.html"},{"type":"function","title":"FlyMachineClient.Machines.create_machine/2","doc":"Creates a new machine in a Fly.io app.","ref":"FlyMachineClient.Machines.html#create_machine/2"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.create_machine/2","doc":"- params: A map containing the machine creation parameters:\n  - app_name: The name of the app to create the machine in (required)\n  - name: The name for the machine (optional)\n  - region: The region to deploy the machine to (optional)\n  - config: Machine configuration map (required)\n  - image: Docker image to use (required)\n  - env: Environment variables map (optional)\n  - services: List of services (optional)\n  - metadata: Metadata map (optional)\n- opts: Optional list of options","ref":"FlyMachineClient.Machines.html#create_machine/2-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.create_machine/2","doc":"{:ok, machine} on success where machine is the created machine data\n{:error, error} on failure","ref":"FlyMachineClient.Machines.html#create_machine/2-returns"},{"type":"function","title":"FlyMachineClient.Machines.destroy_machine/3","doc":"Destroys (deletes) a machine.","ref":"FlyMachineClient.Machines.html#destroy_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.destroy_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to destroy.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#destroy_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.destroy_machine/3","doc":"{:ok, nil} on success.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#destroy_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.get_machine/3","doc":"Gets details of a specific machine.","ref":"FlyMachineClient.Machines.html#get_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.get_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to retrieve.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#get_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.get_machine/3","doc":"{:ok, machine} on success, where machine is the machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#get_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.list_machines/2","doc":"Lists all machines for a given app.","ref":"FlyMachineClient.Machines.html#list_machines/2"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.list_machines/2","doc":"- app_name: The name of the app to list machines for.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#list_machines/2-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.list_machines/2","doc":"{:ok, machines} on success, where machines is a list of machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#list_machines/2-returns"},{"type":"function","title":"FlyMachineClient.Machines.restart_machine/3","doc":"Restarts a machine.","ref":"FlyMachineClient.Machines.html#restart_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.restart_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to restart.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#restart_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.restart_machine/3","doc":"{:ok, machine} on success, where machine is the restarted machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#restart_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.signal_machine/4","doc":"Sends a signal to a machine.","ref":"FlyMachineClient.Machines.html#signal_machine/4"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.signal_machine/4","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to signal.\n- signal: The signal to send (e.g., \"SIGINT\", \"SIGTERM\").\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#signal_machine/4-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.signal_machine/4","doc":"{:ok, machine} on success, where machine is the updated machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#signal_machine/4-returns"},{"type":"function","title":"FlyMachineClient.Machines.start_machine/3","doc":"Starts a stopped machine.","ref":"FlyMachineClient.Machines.html#start_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.start_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to start.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#start_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.start_machine/3","doc":"{:ok, machine} on success, where machine is the started machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#start_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.stop_machine/3","doc":"Stops a running machine.","ref":"FlyMachineClient.Machines.html#stop_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.stop_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to stop.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#stop_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.stop_machine/3","doc":"{:ok, machine} on success, where machine is the stopped machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#stop_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.suspend_machine/3","doc":"Suspends a running machine.","ref":"FlyMachineClient.Machines.html#suspend_machine/3"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.suspend_machine/3","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to suspend.\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#suspend_machine/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.suspend_machine/3","doc":"{:ok, machine} on success, where machine is the suspended machine data.\n{:error, error()} on failure.","ref":"FlyMachineClient.Machines.html#suspend_machine/3-returns"},{"type":"function","title":"FlyMachineClient.Machines.update_machine/2","doc":"Updates an existing machine in a Fly.io app.","ref":"FlyMachineClient.Machines.html#update_machine/2"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.update_machine/2","doc":"- params: A map containing the machine update parameters:\n  - app_name: The name of the app containing the machine (required)\n  - machine_id: The ID of the machine to update (required)\n  - name: New name for the machine (optional)\n  - region: New region for the machine (optional)\n  - config: Updated machine configuration map (optional)\n  - image: New Docker image to use (optional)\n  - env: Updated environment variables map (optional)\n  - services: Updated list of services (optional)\n  - metadata: Updated metadata map (optional)\n- opts: Optional list of options","ref":"FlyMachineClient.Machines.html#update_machine/2-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.update_machine/2","doc":"{:ok, machine} on success where machine is the updated machine data\n{:error, error} on failure","ref":"FlyMachineClient.Machines.html#update_machine/2-returns"},{"type":"function","title":"FlyMachineClient.Machines.wait_for_machine_state/6","doc":"Waits for a machine to reach a specific state.","ref":"FlyMachineClient.Machines.html#wait_for_machine_state/6"},{"type":"function","title":"Parameters - FlyMachineClient.Machines.wait_for_machine_state/6","doc":"- app_name: The name of the app the machine belongs to.\n- machine_id: The ID of the machine to wait for.\n- instance_id: The ID of the instance to wait for.\n- state: The desired state to wait for.\n- timeout: The maximum time to wait (in seconds).\n- opts: Optional. Additional options for the request.","ref":"FlyMachineClient.Machines.html#wait_for_machine_state/6-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Machines.wait_for_machine_state/6","doc":"{:ok, machine} on success, where machine is the machine data after reaching the desired state.\n{:error, error()} on failure or timeout.","ref":"FlyMachineClient.Machines.html#wait_for_machine_state/6-returns"},{"type":"module","title":"FlyMachineClient.Orchestrator","doc":"High-level orchestrator for multi-step or state-aware Fly API operations.\n\nThis module provides higher-level flows that often involve:\n  * Checking resource states (e.g., pending vs. active)\n  * Retrying or waiting for readiness\n  * Handling subtle edge cases where Fly returns 500 or other errors during transitions\n\nExample usage could include:\n- create_app_and_wait/2: Create an app, then poll get_app until the status is no longer \"pending\".\n- create_machine_and_wait/2: Create a machine, wait for it to be \"started\".\n- orchestrated deployments involving multiple resources.","ref":"FlyMachineClient.Orchestrator.html"},{"type":"function","title":"FlyMachineClient.Orchestrator.create_app_and_wait/2","doc":"Creates an app, then waits for it to become active.\nAccepts:\n  - `params`: Map with `:app_name`, `:org_slug`, etc.\n  - `wait_opts`: Options for how long to poll, intervals, etc. (optional)\nReturns `{:ok, app}` or `{:error, reason}`.","ref":"FlyMachineClient.Orchestrator.html#create_app_and_wait/2"},{"type":"function","title":"FlyMachineClient.Orchestrator.create_machine_and_wait/2","doc":"Creates a machine, then waits for it to be in the \"started\" state.\nExample multi-step flow:\n  - create_machine/2\n  - wait_for_machine_state/6","ref":"FlyMachineClient.Orchestrator.html#create_machine_and_wait/2"},{"type":"function","title":"FlyMachineClient.Orchestrator.wait_for_app_active/2","doc":"Waits for the given Fly app to become active.\nPolls get_app until status != \"pending\" or until timeout.\n\n`wait_opts` may include:\n  * `:timeout` (in seconds), default 60\n  * `:interval` (in ms), default 2000","ref":"FlyMachineClient.Orchestrator.html#wait_for_app_active/2"},{"type":"module","title":"FlyMachineClient.Secrets","doc":"Module for managing secrets on Fly.io machines.","ref":"FlyMachineClient.Secrets.html"},{"type":"function","title":"FlyMachineClient.Secrets.create_secret/5","doc":"Creates a new secret for an app.","ref":"FlyMachineClient.Secrets.html#create_secret/5"},{"type":"function","title":"Parameters - FlyMachineClient.Secrets.create_secret/5","doc":"- app_name: The name of the app to create the secret for\n- secret_label: The label/name for the secret\n- secret_type: The type of secret\n- value: The secret value as a binary string or charlist\n- opts: Optional list of options","ref":"FlyMachineClient.Secrets.html#create_secret/5-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Secrets.create_secret/5","doc":"{:ok, nil} on success (201 Created)\n{:error, error} on failure (400 Bad Request)","ref":"FlyMachineClient.Secrets.html#create_secret/5-returns"},{"type":"function","title":"FlyMachineClient.Secrets.destroy_secret/3","doc":"Destroys (deletes) a secret from an app.","ref":"FlyMachineClient.Secrets.html#destroy_secret/3"},{"type":"function","title":"Parameters - FlyMachineClient.Secrets.destroy_secret/3","doc":"- app_name: The name of the app to delete the secret from\n- secret_label: The label/name of the secret to delete\n- opts: Optional list of options","ref":"FlyMachineClient.Secrets.html#destroy_secret/3-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Secrets.destroy_secret/3","doc":"{:ok, nil} on success (200 OK)\n{:error, error} on failure","ref":"FlyMachineClient.Secrets.html#destroy_secret/3-returns"},{"type":"function","title":"FlyMachineClient.Secrets.generate_secret/4","doc":"Generates a new secret for an app.","ref":"FlyMachineClient.Secrets.html#generate_secret/4"},{"type":"function","title":"Parameters - FlyMachineClient.Secrets.generate_secret/4","doc":"- app_name: The name of the app to generate the secret for\n- secret_label: The label/name for the secret\n- secret_type: The type of secret\n- opts: Optional list of options","ref":"FlyMachineClient.Secrets.html#generate_secret/4-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Secrets.generate_secret/4","doc":"{:ok, nil} on success (201 Created)\n{:error, error} on failure (400 Bad Request)","ref":"FlyMachineClient.Secrets.html#generate_secret/4-returns"},{"type":"function","title":"FlyMachineClient.Secrets.list_secrets/2","doc":"Lists all secrets for a given app.","ref":"FlyMachineClient.Secrets.html#list_secrets/2"},{"type":"function","title":"Parameters - FlyMachineClient.Secrets.list_secrets/2","doc":"- app_name: The name of the app to list secrets for\n- opts: Optional list of options","ref":"FlyMachineClient.Secrets.html#list_secrets/2-parameters"},{"type":"function","title":"Returns - FlyMachineClient.Secrets.list_secrets/2","doc":"{:ok, secrets} on success where secrets is a list of secret data\n{:error, error} on failure","ref":"FlyMachineClient.Secrets.html#list_secrets/2-returns"},{"type":"module","title":"FlyMachineClient.Volumes","doc":"API client for managing Fly.io volumes.","ref":"FlyMachineClient.Volumes.html"},{"type":"function","title":"FlyMachineClient.Volumes.create/3","doc":"Create a volume for a specific app.","ref":"FlyMachineClient.Volumes.html#create/3"},{"type":"function","title":"FlyMachineClient.Volumes.create_snapshot/3","doc":"Create a snapshot for a specific volume within an app.","ref":"FlyMachineClient.Volumes.html#create_snapshot/3"},{"type":"function","title":"FlyMachineClient.Volumes.delete/3","doc":"Delete a specific volume within an app by volume ID.","ref":"FlyMachineClient.Volumes.html#delete/3"},{"type":"function","title":"FlyMachineClient.Volumes.extend/4","doc":"Extend a volume's size within an app.","ref":"FlyMachineClient.Volumes.html#extend/4"},{"type":"function","title":"FlyMachineClient.Volumes.get/3","doc":"Get details about a specific volume by its ID within an app.","ref":"FlyMachineClient.Volumes.html#get/3"},{"type":"function","title":"FlyMachineClient.Volumes.list/3","doc":"List all volumes associated with a specific app.","ref":"FlyMachineClient.Volumes.html#list/3"},{"type":"function","title":"FlyMachineClient.Volumes.list_snapshots/3","doc":"List all snapshots for a specific volume within an app.","ref":"FlyMachineClient.Volumes.html#list_snapshots/3"},{"type":"function","title":"FlyMachineClient.Volumes.update/4","doc":"Update a volume's configuration.","ref":"FlyMachineClient.Volumes.html#update/4"},{"type":"task","title":"mix fly_machine_client.clean_test_machines","doc":"Cleans up test resources created during testing.","ref":"Mix.Tasks.FlyMachineClient.CleanTestMachines.html"},{"type":"task","title":"Usage - mix fly_machine_client.clean_test_machines","doc":"mix clean         # Prompt for each deletion\n    mix clean --all   # Delete all without prompting","ref":"Mix.Tasks.FlyMachineClient.CleanTestMachines.html#module-usage"},{"type":"function","title":"Mix.Tasks.FlyMachineClient.CleanTestMachines.run/1","doc":"","ref":"Mix.Tasks.FlyMachineClient.CleanTestMachines.html#run/1"},{"type":"task","title":"mix fly_machine_client.list_test_apps","doc":"Lists all test apps (apps with 'test-app' prefix).","ref":"Mix.Tasks.FlyMachineClient.ListTestApps.html"},{"type":"task","title":"Usage - mix fly_machine_client.list_test_apps","doc":"mix fly_machine_client.list_test_apps","ref":"Mix.Tasks.FlyMachineClient.ListTestApps.html#module-usage"},{"type":"function","title":"Mix.Tasks.FlyMachineClient.ListTestApps.run/1","doc":"","ref":"Mix.Tasks.FlyMachineClient.ListTestApps.html#run/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}